/*
 * This file is part of the Kvkbd project.
 * Copyright (C) 2007-2008 Todor Gyumyushev <yodor@developer.bg>
 * Copyright (C) 2008 Guillaume Martres <smarter@ubuntu.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */

#include "numpadvbutton.h"

NumpadVButton::NumpadVButton(QWidget *parent)
        : VButton(parent)
{

}

NumpadVButton::~NumpadVButton()
{
}

void NumpadVButton::numLockPressed(bool press)
{
    QString txt = press?shiftText:text;
    QPushButton::setText(txt);
    fitText();
}

void NumpadVButton::reposition(int width, int height)
{
    VButton::reposition(width,height);
    fitText();
}

void NumpadVButton::fitText()
{
    bool upd = false;
    int left, top, right, bottom;
    getContentsMargins(&left, &top, &right, &bottom);
    int  w = geometry().width() - left - right - 1; 
    QString oldText=text;
         if (text==tr("Home"))      { if (QFontMetrics(font()).horizontalAdvance(text) > w)   { text=tr("Ho\nme");   upd=true; } } 
    else if (text==tr("PgUp"))      { if (QFontMetrics(font()).horizontalAdvance(text) > w)   { text=tr("Pg\nUp");   upd=true; } }
    else if (text==tr("PgDn"))      { if (QFontMetrics(font()).horizontalAdvance(text) > w)   { text=tr("Pg\nDn");   upd=true; } }
    else if (text==tr("NumL"))      { if (QFontMetrics(font()).horizontalAdvance(text) > w)   { text=tr("Num\nLck"); upd=true; } }
    else if (text==tr("Ho\nme"))    { if (QFontMetrics(font()).horizontalAdvance("Home") < w) { text=tr("Home"); upd=true; } }
    else if (text==tr("Pg\nUp"))    { if (QFontMetrics(font()).horizontalAdvance("PgUp") < w) { text=tr("PgUp"); upd=true; } }
    else if (text==tr("Pg\nDn"))    { if (QFontMetrics(font()).horizontalAdvance("PgDn") < w) { text=tr("PgDn"); upd=true; } }
    else if (text==tr("Num\nLck"))  { if (QFontMetrics(font()).horizontalAdvance("NumL") < w) { text=tr("NumL"); upd=true; } }


    if (upd && QPushButton::text()==oldText) QPushButton::setText(text);
}
